'use strict';

var _fs = require('fs');

var _requiredFields = require('./utilities/requiredFields.js');

var _messages = require('./utilities/messages');

// import { chalkSuccess } from './utilities/chalkConfiguration';
var argv = require('minimist')(process.argv.slice(2)); /* eslint-disable no-console */
/* eslint-disable max-len */
/* eslint-disable no-process-env */


var secureTokenKey = 'secure-token';
var filePathKey = 'file-path';

var apikey = argv[secureTokenKey] || process.env.NPM_REGISTRY_API_KEY;
var authEmail = argv.email || process.env.NPM_REGISTRY_EMAIL;
var registry = argv.registry || process.env.NPM_REGISTRY;

var requiredFields = {
  apikey: apikey,
  authEmail: authEmail,
  registry: registry
};

var missingFields = (0, _requiredFields.missingRequiredFields)(requiredFields);
if (missingFields) {
  process.exit(1);
}

var outputPath = argv[filePathKey];
var nextLine = '\n';

console.log('Creating a temporary .npmrc file which will be used to authenticate');

var npmConfigurationFile = outputPath ? outputPath + '/.npmrc' : './.npmrc';

var fileContent = '_auth=' + apikey + nextLine + 'always-auth=true' + nextLine + 'email=' + authEmail + nextLine + 'registry=' + registry;

(0, _fs.writeFileSync)(npmConfigurationFile, fileContent);
(0, _messages.successMessage)();